package cn.com.tenlion.bigdata.dao.bigdatatemplate;

import cn.com.tenlion.bigdata.pojo.dtos.bigdatatemplate.BigdataTemplateDTO;
import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.exceptions.UpdateException;
import org.springframework.stereotype.Repository;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: IBigdataTemplateDao
 * @Description: 大数据展示的模板管理
 * @Author: WenG
 * @Date: 2020-10-20 10:49
 * @Version: 1.0
 **/
@Repository
public interface IBigdataTemplateDao {

    /**
     * 新增大数据展示的模板管理
     *
     * @param params
     * @throws SaveException
     */
    void saveBigdataTemplate(Map<String, Object> params) throws SaveException;

    /**
     * 删除大数据展示的模板管理
     *
     * @param params
     * @throws RemoveException
     */
    void removeBigdataTemplate(Map<String, Object> params) throws RemoveException;

    /**
    * 删除大数据展示的模板管理（物理）
    *
    * @param params
    * @throws RemoveException
    */
    void deleteBigdataTemplate(Map<String, Object> params) throws RemoveException;

    /**
     * 修改大数据展示的模板管理
     *
     * @param params
     * @throws UpdateException
     */
    void updateBigdataTemplate(Map<String, Object> params) throws UpdateException;

    /**
     * 大数据展示的模板管理详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    BigdataTemplateDTO getBigdataTemplate(Map<String, Object> params) throws SearchException;

    /**
     * 大数据展示的模板管理列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<BigdataTemplateDTO> listBigdataTemplate(Map<String, Object> params) throws SearchException;

    /**
    * 大数据展示的模板管理统计
    *
    * @param params
    * @return
    * @throws SearchException
    */
    Integer countBigdataTemplate(Map<String, Object> params) throws SearchException;

    BigdataTemplateDTO getBigdataTemplateByCode(String bigdataTemplateCode) throws SearchException;

    void updataBigdataTemplateUrl(Map<String, Object> updateParams) throws UpdateException;

    void updateBigdataTemplatePublishStatus(Map<String, Object> params) throws UpdateException;

    List<Map<String, Object>> querySqlAll(String sql) throws SearchException;

    void updateBigdataTemplateContent(Map<String, Object> params) throws UpdateException;
}